// this object works with the leading character
object ".FTL.Master"
{
    requires 0.2.0
    hide_unless_in_editor_mode
    always_active

    // -------------------------------------------------------
    // Character selector
    // -------------------------------------------------------
    state "main"
    {
        hide
        let "$_ftl_player_direction = 1"
    }

    state "destroy"
    {
        destroy
    }

    state "Surge"
    {
        observe_player "Surge"
        change_state "Start AI"
    }

    state "Neon"
    {
        observe_player "Neon"
        change_state "Start AI"
    }

    state "Charge"
    {
        observe_player "Charge"
        change_state "Start AI"
    }

    // -------------------------------------------------------
    // Simple Artificial Intelligence
    // -------------------------------------------------------
    state "Start AI"
    {
        attach_to_player 0 0
        let "$_ftl_master_xpos = player_xpos()"
        let "$_ftl_master_ypos = player_ypos()"
        let "$_ftl_timer += dt()"

        on_button_down "down" "down"
        on_button_down "left" "left"
        on_button_down "right" "right"
    }

    state "left"
    {
        let "$_ftl_player_direction = -1"
        change_state "Start AI"
    }

    state "right"
    {
        let "$_ftl_player_direction = 1"
        change_state "Start AI"
    }

    // -------------------------------------------------------
    // Charge and roll
    // -------------------------------------------------------
    state "down"
    {
        on_button_down "fire1" "tell others to charge up"
        change_state "Start AI"
    }

    state "tell others to charge up"
    {
        change_closest_object_state ".FTL.Slave1" "Charge up"
        change_closest_object_state ".FTL.Slave2" "Charge up"
        change_state "wait until roll"
    }

    state "wait until roll"
    {
        attach_to_player 0 0
        let "$_ftl_master_xpos = player_xpos()"
        let "$_ftl_master_ypos = player_ypos()"
        let "$_ftl_timer += dt()"

        on_button_up "down" "tell others to roll"
    }

    state "tell others to roll"
    {
        change_closest_object_state ".FTL.Slave1" "Roll"
        change_closest_object_state ".FTL.Slave2" "Roll"
        change_state "Start AI"
    }
}
